{ Hello Demo}
program Hello;
{$MODE OBJFPC}{$H+}
uses 
  FObjects;
type
  { Custom window }
  PHelloWindow = ^THelloWindow;
  THelloWindow = object(TWindow)
    constructor Init;
    function ProcessNotification(Child: PWindowsObject; 
      NotifyCode: Integer): Boolean; virtual;
  end;
  { Application class }
  TMyApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;
{ THelloWindow }
constructor THelloWindow.Init;
var
  Button: PButton;
begin
  inherited Init(nil, 'Hello');
  New(Button, Init(@Self, 100, 'Hello, world!', 10, 10, 100, 25, False));
end;
function THelloWindow.ProcessNotification(Child: PWindowsObject; 
  NotifyCode: Integer): Boolean;
begin
  if (NotifyCode=cn_Clicked) and (Child^.GetId=100) then begin
    CloseWindow;
    Exit(True);
  end;
  Result:=inherited ProcessNotification(Child, NotifyCode);
end;
{ TMyApp }
procedure TMyApp.InitMainWindow;
begin
  MainWindow:=New(PHelloWindow, Init);
end;
{ Main }
var
  App: TMyApp;
begin
  App.Init('Hello Demo');
  App.Run;
  App.Done;
end.
